diff --git a/src/postgres/src/backend/access/yb_access/yb_scan.c b/src/postgres/src/backend/access/yb_access/yb_scan.c
index 4c51848fa048..cb987f23fc1a 100644
--- a/src/postgres/src/backend/access/yb_access/yb_scan.c
+++ b/src/postgres/src/backend/access/yb_access/yb_scan.c
@@ -2744,7 +2744,8 @@ YBCLockTuple(Relation relation, Datum ybctid, RowMarkType mode, LockWaitPolicy w
 	exec_params.limit_count = 1;
 	exec_params.rowmark = mode;
 	exec_params.wait_policy = wait_policy;
-  exec_params.statement_in_txn_limit = estate->yb_exec_params.statement_in_txn_limit;
+  exec_params.stmt_in_txn_limit_for_reads_already_set =
+		estate->yb_exec_params.stmt_in_txn_limit_for_reads_already_set;
 
 	HTSU_Result res = HeapTupleMayBeUpdated;
 	MemoryContext exec_context = GetCurrentMemoryContext();
diff --git a/src/postgres/src/backend/executor/execUtils.c b/src/postgres/src/backend/executor/execUtils.c
index 0850275dcd71..ff8c044bfc7c 100644
--- a/src/postgres/src/backend/executor/execUtils.c
+++ b/src/postgres/src/backend/executor/execUtils.c
@@ -174,14 +174,7 @@ CreateExecutorState(void)
 	estate->yb_es_is_single_row_modify_txn = false;
 	estate->yb_es_is_fk_check_disabled = false;
 	estate->yb_conflict_slot = NULL;
-	/*
-	 * The in txn limit used for this query. This will be initialized by the first
-	 * read operation invoked for this query, and all later reads performed by
-	 * this query will not read any data written past this time.
-	 *
-	 * TODO: Each query can have multiple "EState"s. Fix logic for such cases.
-	 */
-	estate->yb_es_in_txn_limit_ht = 0;
+	estate->yb_es_in_txn_limit_for_reads_already_set = false;
 
 	estate->yb_exec_params.limit_count = 0;
 	estate->yb_exec_params.limit_offset = 0;
@@ -189,12 +182,14 @@ CreateExecutorState(void)
 	estate->yb_exec_params.rowmark = -1;
 	estate->yb_exec_params.is_index_backfill = false;
 	/*
-	 * Pointer to the query's in txn limit. This pointer is passed
-	 * down to all the DocDB read operations invoked for this query. Only
-	 * the first read operation initializes its value, and all the other
-	 * operations ensure that they don't read any value written past this time.
+	 * Pointer to a bool which helps identify if the if the in txn limit for read operations is
+	 * already picked for the current query. This pointer is passed down to all the DocDB read
+	 * operations invoked for this query. Only the first read operation initializes its value, and all
+	 * the other operations ensure that they don't read any value written with a timestamp after the
+	 * in_txn_limit that was picked.
 	 */
-	estate->yb_exec_params.statement_in_txn_limit = &estate->yb_es_in_txn_limit_ht;
+	estate->yb_exec_params.stmt_in_txn_limit_for_reads_already_set =
+		&estate->yb_es_in_txn_limit_for_reads_already_set;
 
 	return estate;
 }
diff --git a/src/postgres/src/include/nodes/execnodes.h b/src/postgres/src/include/nodes/execnodes.h
index a27ab2cd4414..664a1b3ac02a 100644
--- a/src/postgres/src/include/nodes/execnodes.h
+++ b/src/postgres/src/include/nodes/execnodes.h
@@ -598,12 +598,18 @@ typedef struct EState
 	YBCPgExecParameters yb_exec_params;
 
 	/*
-	 *  The in txn limit used for this query. This value is initialized
-	 *  to 0, and later updated by the first read operation initiated for this
-	 *  query. All later read operations are then ensured that they will never
-	 *  read any data written past this time.
+	 * Helps identify if the in txn limit for read operations is already picked for the current SQL
+	 * query. This value is initialized to false, and later updated to true by the first read
+	 * operation initiated for this query since the in txn limit would have been picked then. All
+	 * later read operations are then ensured that they will never read any data written by the
+	 * current query.
+	 *
+	 * TODO: Each query can have multiple "EState"s. Fix logic for such cases. Ensure that only one
+	 * in_txn_limit is used for reads in one statement.
+	 *
+	 * See ReadHybridTimePB for details about in_txn_limit.
 	 */
-	uint64_t yb_es_in_txn_limit_ht;
+	bool yb_es_in_txn_limit_for_reads_already_set;
 } EState;
 
 /*
diff --git a/src/yb/common/common.proto b/src/yb/common/common.proto
index 100a5b0421fe..2ae7b2d80280 100644
--- a/src/yb/common/common.proto
+++ b/src/yb/common/common.proto
@@ -394,6 +394,16 @@ message ReadHybridTimePB {
 
   optional fixed64 global_limit_ht = 3;
 
+  // When a transaction reads data, all committed writes of other transactions with a timestamp
+  // <= read_ht are visible.
+  //
+  // However, a transaction's reads should be able to see all provisional writes from the same
+  // transaction irrespective of read_ht, except some based on additional constraints for YSQL (as
+  // described in src/yb/yql/pggate/README.txt). The query layer uses in_txn_limit_ht to meet these
+  // constraints. If in_txn_limit_ht is set, any operation will not be able to read provisional
+  // writes from the same transaction which have a write timestamp higher than the in_txn_limit_ht.
+  //
+  // src/yb/yql/pggate/README.txt also explains how this works along with YSQL's buffering logic.
   optional fixed64 in_txn_limit_ht = 4;
 
   optional fixed64 local_limit_ht = 5;
diff --git a/src/yb/integration-tests/mini_cluster.cc b/src/yb/integration-tests/mini_cluster.cc
index bf6f1835ae1b..e674212304d8 100644
--- a/src/yb/integration-tests/mini_cluster.cc
+++ b/src/yb/integration-tests/mini_cluster.cc
@@ -109,6 +109,7 @@ DECLARE_int64(rocksdb_compact_flush_rate_limit_bytes_per_sec);
 DECLARE_string(use_private_ip);
 DECLARE_int32(load_balancer_initial_delay_secs);
 DECLARE_int32(transaction_table_num_tablets);
+DECLARE_string(time_source);
 
 namespace yb {
 
@@ -193,7 +194,9 @@ MiniCluster::~MiniCluster() {
   Shutdown();
 }
 
-Status MiniCluster::Start(const std::vector<tserver::TabletServerOptions>& extra_tserver_options) {
+Status MiniCluster::Start(
+    const std::vector<tserver::TabletServerOptions>& extra_tserver_options,
+    const std::vector<uint16_t>& tserver_clock_skew_ms) {
   CHECK(!fs_root_.empty()) << "No Fs root was provided";
   CHECK(!running_);
 
@@ -244,6 +247,10 @@ Status MiniCluster::Start(const std::vector<tserver::TabletServerOptions>& extra
   }
 
   for (size_t i = 0; i < options_.num_tablet_servers; i++) {
+    if (tserver_clock_skew_ms.size() > i) {
+      FLAGS_time_source = "skewed,-" + std::to_string(tserver_clock_skew_ms[i]);
+    }
+
     if (!extra_tserver_options.empty()) {
       RETURN_NOT_OK_PREPEND(AddTabletServer(extra_tserver_options[i]),
                             Substitute("Error adding TS $0", i));
@@ -252,6 +259,9 @@ Status MiniCluster::Start(const std::vector<tserver::TabletServerOptions>& extra
                             Substitute("Error adding TS $0", i));
     }
 
+    if (tserver_clock_skew_ms.size() > i) {
+      FLAGS_time_source = "";
+    }
   }
 
   RETURN_NOT_OK_PREPEND(WaitForTabletServerCount(options_.num_tablet_servers),
diff --git a/src/yb/integration-tests/mini_cluster.h b/src/yb/integration-tests/mini_cluster.h
index bb9b024deb1c..fce4e033def2 100644
--- a/src/yb/integration-tests/mini_cluster.h
+++ b/src/yb/integration-tests/mini_cluster.h
@@ -119,7 +119,9 @@ class MiniCluster : public MiniClusterBase {
   // All servers run on the loopback interface with ephemeral ports.
   Status Start(
       const std::vector<tserver::TabletServerOptions>& extra_tserver_options =
-      std::vector<tserver::TabletServerOptions>());
+      std::vector<tserver::TabletServerOptions>(),
+      const std::vector<uint16_t>& tserver_clock_skew_ms =
+      std::vector<uint16_t>());
 
   // Like the previous method but performs initialization synchronously, i.e.
   // this will wait for all TS's to be started and initialized. Tests should
diff --git a/src/yb/tserver/pg_client.proto b/src/yb/tserver/pg_client.proto
index fa03edef40fb..ff0ca7271944 100644
--- a/src/yb/tserver/pg_client.proto
+++ b/src/yb/tserver/pg_client.proto
@@ -375,7 +375,7 @@ message PgPerformOptionsPB {
   uint32 isolation = 2;
   bool ddl_mode = 3;
   uint64 txn_serial_no = 4;
-  fixed64 in_txn_limit_ht = 5;
+  fixed64 DEPRECATED_in_txn_limit_ht = 5;
   bool use_existing_priority = 6;
   fixed64 priority = 7;
   bool restart_transaction = 8;
@@ -389,6 +389,17 @@ message PgPerformOptionsPB {
   uint32 active_sub_transaction_id = 16;
   CachingInfo caching_info = 17;
   bool read_from_followers = 18;
+
+  // If true, reset the in_txn_limit for ops of type PgsqlReadRequestPB to the current hybrid time.
+  // This is usually done by the YSQL query layer on the first batch of read ops sent by a new SQL
+  // statement. Post that, all PgsqlReadRequestPB ops should use that same in_txn_limit until a new
+  // statemnt starts.
+  //
+  // For ops of type PgsqlWriteRequestPB, a new in_txn_limit is picked for every new batch of these
+  // ops.
+  //
+  // See src/yb/yql/pggate/README.txt for more information.
+  bool reset_in_txn_limit_for_read_ops = 19;
 }
 
 message PgPerformRequestPB {
diff --git a/src/yb/tserver/pg_client_session.cc b/src/yb/tserver/pg_client_session.cc
index 994a665a4938..34bc4f72c092 100644
--- a/src/yb/tserver/pg_client_session.cc
+++ b/src/yb/tserver/pg_client_session.cc
@@ -26,6 +26,7 @@
 #include "yb/client/transaction_pool.h"
 #include "yb/client/yb_op.h"
 
+#include "yb/common/hybrid_time.h"
 #include "yb/common/ql_type.h"
 #include "yb/common/pgsql_error.h"
 #include "yb/common/transaction_error.h"
@@ -279,7 +280,7 @@ Status GetTable(const TableId& table_id, PgTableCache* cache, client::YBTablePtr
 
 Result<PgClientSessionOperations> PrepareOperations(
     PgPerformRequestPB* req, client::YBSession* session, rpc::Sidecars* sidecars,
-    PgTableCache* table_cache) {
+    PgTableCache* table_cache, bool *has_writes, bool *has_reads) {
   auto write_time = HybridTime::FromPB(req->write_time());
   std::vector<std::shared_ptr<client::YBPgsqlOp>> ops;
   ops.reserve(req->ops().size());
@@ -293,6 +294,7 @@ Result<PgClientSessionOperations> PrepareOperations(
   const auto read_from_followers = req->options().read_from_followers();
   for (auto& op : *req->mutable_ops()) {
     if (op.has_read()) {
+      *has_reads = true;
       auto& read = *op.mutable_read();
       RETURN_NOT_OK(GetTable(read.table_id(), table_cache, &table));
       auto read_op = std::make_shared<client::YBPgsqlReadOp>(table, sidecars, &read);
@@ -302,6 +304,7 @@ Result<PgClientSessionOperations> PrepareOperations(
       ops.push_back(read_op);
       session->Apply(std::move(read_op));
     } else {
+      *has_writes = true;
       auto& write = *op.mutable_write();
       RETURN_NOT_OK(GetTable(write.table_id(), table_cache, &table));
       auto write_op = std::make_shared<client::YBPgsqlWriteOp>(table, sidecars, &write);
@@ -741,9 +744,24 @@ Status PgClientSession::Perform(
     }
   }
 
-  auto session_info = VERIFY_RESULT(SetupSession(*req, context->GetClientDeadline()));
-  auto* session = session_info.first.session.get();
-  auto ops = VERIFY_RESULT(PrepareOperations(req, session, &context->sidecars(), &table_cache_));
+  PgClientSessionKind kind;
+  if (options.use_catalog_session()) {
+    SCHECK(!options.read_from_followers(),
+           InvalidArgument,
+           "Reading catalog from followers is not allowed");
+    kind = PgClientSessionKind::kCatalog;
+  } else if (options.ddl_mode()) {
+    kind = PgClientSessionKind::kDdl;
+  } else {
+    kind = PgClientSessionKind::kPlain;
+  }
+
+  auto session_info = VERIFY_RESULT(SetupSession(*req, context->GetClientDeadline(), kind));
+  auto* session = session_info.first->session.get();
+  bool has_writes = false;
+  bool has_reads = false;
+  auto ops = VERIFY_RESULT(
+    PrepareOperations(req, session, &context->sidecars(), &table_cache_, &has_writes, &has_reads));
   auto ops_count = ops.size();
   auto data = std::make_shared<PerformData>(PerformData {
     .session_id = id_,
@@ -755,7 +773,44 @@ Status PgClientSession::Perform(
     .cache_setter = std::move(setter)
   });
 
-  auto transaction = session_info.first.transaction;
+  auto transaction = session_info.first->transaction;
+  if (kind == PgClientSessionKind::kPlain && transaction != nullptr) {
+    // TODO: Shouldn't the below logic for DDL transactions as well?
+
+    // We set in_txn_limit only if we are in a transaction.
+
+    // A batch of writes always needs to have the current hybrid time as the in_txn_limit.
+    // See requirement 2b) in src/yb/yql/pggate/README.txt.
+    auto& in_txn_limit_for_reads = session_info.first->in_txn_limit_for_reads;
+    if (has_writes && !has_reads) {
+      auto in_txn_limit = clock_->Now();
+      session->SetInTxnLimit(in_txn_limit);
+      VLOG_WITH_PREFIX(3) << "Using current hybrid time as in txn limit for write ops: "
+                          << in_txn_limit;
+    } else if (has_reads && !has_writes) {
+      if (options.reset_in_txn_limit_for_read_ops()) {
+        in_txn_limit_for_reads = clock_->Now();
+        session->SetInTxnLimit(in_txn_limit_for_reads);
+        VLOG_WITH_PREFIX(3) << "Resetting in txn limit for read ops to : "
+                            << in_txn_limit_for_reads;
+      } else {
+        // If not resetting the in txn limit, it should have already been set earlier.
+        DCHECK(in_txn_limit_for_reads.is_valid());
+        VLOG_WITH_PREFIX(3) << "Reusing in txn limit for read ops : " << in_txn_limit_for_reads;
+      }
+    } else if (has_reads && has_writes) {
+      SCHECK(options.reset_in_txn_limit_for_read_ops(),
+             InvalidArgument,
+             "Can't batch ops of type PgsqlReadRequestPB and PgsqlWriteRequestPB in case the "
+             "in_txn_limit for the read ops was already set for the given SQL statement. This is "
+             "because a new batch of write ops should always use the current hybrid time.");
+      in_txn_limit_for_reads = clock_->Now();
+      session->SetInTxnLimit(in_txn_limit_for_reads);
+      VLOG_WITH_PREFIX(3) << "Resetting in txn limit for read ops to : " << in_txn_limit_for_reads
+                          << ". Using the same for write ops batched with the read ops.";
+    }
+  }
+
   session->FlushAsync([this, data, transaction, ops_count](client::FlushStatus* flush_status) {
     data->FlushDone(flush_status);
     if (transaction) {
@@ -829,22 +884,17 @@ Status PgClientSession::UpdateReadPointForXClusterConsistentReads(
   return Status::OK();
 }
 
-Result<std::pair<PgClientSession::SessionData, PgClientSession::UsedReadTimePtr>>
-PgClientSession::SetupSession(const PgPerformRequestPB& req, CoarseTimePoint deadline) {
+Result<std::pair<PgClientSession::SessionData*, PgClientSession::UsedReadTimePtr>>
+PgClientSession::SetupSession(
+    const PgPerformRequestPB& req, CoarseTimePoint deadline, PgClientSessionKind kind) {
   const auto& options = req.options();
-  PgClientSessionKind kind;
-  if (options.use_catalog_session()) {
-    SCHECK(!options.read_from_followers(),
-           InvalidArgument,
-           "Reading catalog from followers is not allowed");
-    kind = PgClientSessionKind::kCatalog;
+  if (kind == PgClientSessionKind::kCatalog) {
     EnsureSession(kind);
-  } else if (options.ddl_mode()) {
-    kind = PgClientSessionKind::kDdl;
+  } else if (kind == PgClientSessionKind::kDdl) {
     EnsureSession(kind);
     RETURN_NOT_OK(GetDdlTransactionMetadata(true /* use_transaction */, deadline));
   } else {
-    kind = PgClientSessionKind::kPlain;
+    DCHECK(kind == PgClientSessionKind::kPlain);
     RETURN_NOT_OK(BeginTransactionIfNecessary(options, deadline));
   }
 
@@ -860,6 +910,10 @@ PgClientSession::SetupSession(const PgPerformRequestPB& req, CoarseTimePoint dea
     }
     Transaction(kind) = VERIFY_RESULT(RestartTransaction(session, transaction));
     transaction = Transaction(kind).get();
+    if (kind == PgClientSessionKind::kPlain) {
+      sessions_[to_underlying(PgClientSessionKind::kPlain)].in_txn_limit_for_reads =
+          HybridTime();
+    }
   } else {
     RSTATUS_DCHECK(
         kind == PgClientSessionKind::kPlain ||
@@ -884,6 +938,8 @@ PgClientSession::SetupSession(const PgPerformRequestPB& req, CoarseTimePoint dea
             std::shared_ptr<UsedReadTime>(shared_from_this(), &plain_session_used_read_time_));
         std::lock_guard<simple_spinlock>  guard(plain_session_used_read_time_.lock);
         plain_session_used_read_time_.value = ReadHybridTime();
+        sessions_[to_underlying(PgClientSessionKind::kPlain)].in_txn_limit_for_reads =
+            HybridTime();
       }
       VLOG_WITH_PREFIX(3) << "Reset read time: " << session->read_point()->GetReadTime();
     } else {
@@ -903,12 +959,6 @@ PgClientSession::SetupSession(const PgPerformRequestPB& req, CoarseTimePoint dea
 
   if (!options.ddl_mode() && !options.use_catalog_session()) {
     txn_serial_no_ = options.txn_serial_no();
-
-    const auto in_txn_limit = HybridTime::FromPB(options.in_txn_limit_ht());
-    if (in_txn_limit) {
-      VLOG_WITH_PREFIX(3) << "In txn limit: " << in_txn_limit;
-      session->SetInTxnLimit(in_txn_limit);
-    }
   }
 
   session->SetDeadline(deadline);
@@ -918,7 +968,7 @@ PgClientSession::SetupSession(const PgPerformRequestPB& req, CoarseTimePoint dea
     transaction->SetActiveSubTransaction(options.active_sub_transaction_id());
   }
 
-  return std::make_pair(sessions_[to_underlying(kind)], used_read_time);
+  return std::make_pair(&sessions_[to_underlying(kind)], used_read_time);
 }
 
 std::string PgClientSession::LogPrefix() {
@@ -943,6 +993,7 @@ Status PgClientSession::BeginTransactionIfNecessary(
     txn->Abort();
     session->SetTransaction(nullptr);
     txn = nullptr;
+    sessions_[to_underlying(PgClientSessionKind::kPlain)].in_txn_limit_for_reads = HybridTime();
   }
 
   if (isolation == IsolationLevel::NON_TRANSACTIONAL) {
@@ -958,6 +1009,7 @@ Status PgClientSession::BeginTransactionIfNecessary(
         : Status::OK();
   }
 
+  VLOG_WITH_PREFIX(2) << "Initiating a distributed transaction";
   txn = transaction_pool_provider_().Take(
       client::ForceGlobalTransaction(options.force_global_transaction()), deadline);
   txn->SetLogPrefixTag(kTxnLogPrefixTag, id_);
diff --git a/src/yb/tserver/pg_client_session.h b/src/yb/tserver/pg_client_session.h
index d602cf07d958..a9a844e6195c 100644
--- a/src/yb/tserver/pg_client_session.h
+++ b/src/yb/tserver/pg_client_session.h
@@ -85,6 +85,12 @@ class PgClientSession : public std::enable_shared_from_this<PgClientSession> {
   struct SessionData {
     client::YBSessionPtr session;
     client::YBTransactionPtr transaction;
+    // in_txn_limit_for_reads isn't applicable only for sessions of type PgClientSessionKind::kDdl
+    // and PgClientSessionKind::kCatalog. It is used to ensure that every new client level statement
+    // in YSQL uses one in_txn_limit for all ops of type PgsqlReadRequestPB in that statement.
+    //
+    // Refer ReadHybridTimePB for details on in_txn_limit.
+    HybridTime in_txn_limit_for_reads;
   };
 
   using UsedReadTimePtr = std::weak_ptr<UsedReadTime>;
@@ -118,8 +124,8 @@ class PgClientSession : public std::enable_shared_from_this<PgClientSession> {
   Result<client::YBTransactionPtr> RestartTransaction(
       client::YBSession* session, client::YBTransaction* transaction);
 
-  Result<std::pair<SessionData, PgClientSession::UsedReadTimePtr>> SetupSession(
-      const PgPerformRequestPB& req, CoarseTimePoint deadline);
+  Result<std::pair<SessionData*, PgClientSession::UsedReadTimePtr>> SetupSession(
+      const PgPerformRequestPB& req, CoarseTimePoint deadline, PgClientSessionKind kind);
   Status ProcessResponse(
       const PgClientSessionOperations& operations, const PgPerformRequestPB& req,
       PgPerformResponsePB* resp, rpc::RpcContext* context);
diff --git a/src/yb/yql/pggate/README.txt b/src/yb/yql/pggate/README.txt
new file mode 100644
index 000000000000..2002419bb325
--- /dev/null
+++ b/src/yb/yql/pggate/README.txt
@@ -0,0 +1,112 @@
+Buffering in YSQL
+-----------------
+
+Allowing the YSQL execution engine to make progress without waiting for the
+actual work to be done on the tablet servers (via rpcs) helps batch multiple
+operations in one rpc. This allows lesser consumption of resources and reduces
+overall latency when one operation doesn't have to wait for another to complete.
+Also, asynchronously flushing buffers while YSQL performs local work can help
+reduce latency further (for example, in case of COPY command). For these reasons,
+YSQL uses buffering as much as possible with various constraints to ensure
+correctness.
+
+Requirements
+------------
+
+While delaying actual work using buffering can give various performance gains,
+YSQL has the following constraints to ensure correctness:
+
+1) Read ops from a SQL statement should not be able to see writes done as part of the same
+statement. This is required to ensure that statements like
+"INSERT INTO table VALUES SELECT ... FROM table" don't end up in an endless cycle of reading
+what they wrote to write more data.
+
+2) A write op might also under the hood read some data in docdb.
+   a) It should not be able to see writes done as part of the same op.
+   b) However, it should be able to see writes done as part of previous ops in the same
+      transaction (could also be ops part of the same statment, unlike the requirement for read
+      ops).
+
+The query layer uses in_txn_limit_ht (see ReadHybridTimePB) to provide the tserver with necessary
+information to acheive (1) & (2). If in_txn_limit_ht is set, any operation will not be able to read
+provisional writes from the same transaction which have a write timestamp higher than the
+in_txn_limit_ht.
+
+YSQL acheives requirements (1) & (2) as follows:
+
+1) for each new SQL statement, the current hybrid time is picked as the in_txn_limit which is
+used for all reads that will be performed as part of that statement. Also, any write from a previous
+SQL statement that a read is supposed to see, should have completed before the in_txn_limit is
+picked; so that the write timestamp of that write is lower than the in_txn_limit of the read.
+(See PgSession::RunHelper::Apply() where this is ensured)
+
+2)
+
+a) every batch of writes pick the current hybrid time as the in_txn_limit before any execution. So,
+a write op won't be able to see its own writes. (See PgClientSession::Perform() where this is
+ensured)
+
+b) a write op should be able to read data from previous writes to the same row. So if 2 ops change
+the same row one after the other, the one which came in later should see the modification by the
+earlier write op. Given this, the query layer does the following to ensure all later writes see
+modification of earlier writes:
+    
+   i) ensures that no batch of writes has 2 writes to the same row. (See
+   PgOperationBuffer::Impl::DoAdd() where this is ensured)
+
+   ii) Since, every batch of writes pick the current hybrid time as the in_txn_limit, if 2 batch
+   of writes touch the same row, the later batch will pick an in_txn_limit only after the earlier
+   batch is done. This ensures that the write timestamp of any write in the former batch is lower
+   than the in_txn_limit picked by the latter batch.
+
+Given the above, this is how writes and reads are buffered and flushed:
+
+1) Writes:
+
+Writes from multiple SQL statements can be buffered until future operations don't depend on the
+result of the writes. The statements that buffered writes can make progress assuming the writes were
+successful. This can be done because if an error in a buffered write is seen late during execution,
+it would anyway rollback the whole ongoing transaction and void any processing that occurred from
+SQL statements after the write.
+
+Writes are buffered in PgSession::buffer_. This buffer can possibly store writes of multiple
+SQL statements of the same transaction before flushing. Reads can't be buffered in
+PgSession::buffer_.
+
+A flush can either if the buffer is full or if later execution either depends on the result of the
+writes/ requires them to complete before making progress. The following scenarios should be handled:
+
+  1) there is a write op to the same row. Flush to satisfy requirement 2b).
+  2) a read op is being performed. Reads should be able to see the modifications done by
+     writes from previous statements.
+  3) the query engine explicitly flushes. This could happen because:
+
+      a) the TRY block in a TRY catch is ending and we better catch any exception from buffered ops
+      b) beginning or releasing a sub-transaction i.e., save point (see 373c476d)
+      c) in functions/ procedures, a statement with possible non-transactional side-effects
+         is going to be executed (see d46e18cc)
+      d) Before each new statement in READ COMMITTED isolation
+      e) Committing a transaction
+      f) Entering/ exiting separate DDL transaction mode
+      g) When the outer most standard_ExecutorFinish is done (i.e., not a nested executor). This
+         usually happens when the topmost i.e., outer-level SQL statement is down executing. For
+         example, in case of a call to a PL/pgsql function, that is the outer SQL statement and all
+         SQL statements in the function result in nested execution.
+      h) d) COPY command (TODO: explain this)
+
+Buffering has 2 session level configurables: ysql_session_max_batch_size and ysql_max_in_flight_ops.
+See guc.c to understand what they do.
+
+NOTE: in case the buffer is flushed just because ysql_session_max_batch_size was reached, YSQL
+will not wait for the response of the flushed operations. Instead it will track those as in-flight
+operations and perform error-handling for those later when required. This helps improve latency of
+situations like the COPY command where the YSQL execution engine doesn't have to block on in-flight
+writes and can instead read the local file for buffering further writes while the flushed writes
+are being completed on the TServer. See ad4a9914 for detailed summary.
+
+In other cases when the buffer is flushed due to a dependency, a response to the flushed operations
+will be waited upon before making progress.
+
+2) Reads:
+  These aren't buffered because usually the output of a read is required to make progress in the
+  query layer.
diff --git a/src/yb/yql/pggate/pg_doc_op.cc b/src/yb/yql/pggate/pg_doc_op.cc
index ae2d52129b26..693adb9ee0f5 100644
--- a/src/yb/yql/pggate/pg_doc_op.cc
+++ b/src/yb/yql/pggate/pg_doc_op.cc
@@ -201,8 +201,8 @@ Status PgDocResult::ProcessSparseSystemColumns(std::string *reservoir) {
 
 //--------------------------------------------------------------------------------------------------
 
-PgDocResponse::PgDocResponse(PerformFuture future, uint64_t in_txn_limit)
-    : holder_(PerformInfo{.future = std::move(future), .in_txn_limit = in_txn_limit}) {}
+PgDocResponse::PgDocResponse(PerformFuture future)
+    : holder_(PerformInfo{.future = std::move(future)}) {}
 
 PgDocResponse::PgDocResponse(ProviderPtr provider)
     : holder_(std::move(provider)) {}
@@ -216,7 +216,7 @@ bool PgDocResponse::Valid() const {
 Result<PgDocResponse::Data> PgDocResponse::Get(MonoDelta* wait_time) {
   if (std::holds_alternative<PerformInfo>(holder_)) {
     auto& info = std::get<PerformInfo>(holder_);
-    return Data(VERIFY_RESULT(info.future.Get(wait_time)), info.in_txn_limit);
+    return Data(VERIFY_RESULT(info.future.Get(wait_time)));
   }
   // Detach provider pointer after first usage to make PgDocResponse::Valid return false.
   ProviderPtr provider;
@@ -314,7 +314,7 @@ Status PgDocOp::SendRequestImpl(ForceNonBufferable force_non_bufferable) {
   VLOG(1) << "Number of operations to send: " << send_count;
   response_ = VERIFY_RESULT(sender_(
       pg_session_.get(), pgsql_ops_.data(), send_count,
-      *table_, GetInTxnLimit(), force_non_bufferable));
+      *table_, GetInTxnLimitForReadsAlreadySet(), force_non_bufferable));
   return Status::OK();
 }
 
@@ -338,7 +338,6 @@ Result<std::list<PgDocResult>> PgDocOp::ProcessResponseImpl(
   }
   const auto& data = *response;
   auto result = VERIFY_RESULT(ProcessCallResponse(*data.response));
-  GetInTxnLimit() = data.in_txn_limit;
   RETURN_NOT_OK(CompleteProcessResponse());
   return result;
 }
@@ -395,9 +394,11 @@ Result<std::list<PgDocResult>> PgDocOp::ProcessCallResponse(const rpc::CallRespo
   return result;
 }
 
-uint64_t& PgDocOp::GetInTxnLimit() {
-  return exec_params_.statement_in_txn_limit ? *exec_params_.statement_in_txn_limit
-                                             : in_txn_limit_;
+bool* PgDocOp::GetInTxnLimitForReadsAlreadySet() {
+  return
+      exec_params_.stmt_in_txn_limit_for_reads_already_set ?
+          exec_params_.stmt_in_txn_limit_for_reads_already_set :
+          &in_txn_limit_for_reads_already_set_;
 }
 
 Status PgDocOp::CreateRequests() {
@@ -424,10 +425,10 @@ Status PgDocOp::CompleteRequests() {
 
 Result<PgDocResponse> PgDocOp::DefaultSender(
     PgSession* session, const PgsqlOpPtr* ops, size_t ops_count, const PgTableDesc& table,
-    uint64_t in_txn_limit, ForceNonBufferable force_non_bufferable) {
+    bool* in_txn_limit_for_reads_already_set, ForceNonBufferable force_non_bufferable) {
   auto result = VERIFY_RESULT(session->RunAsync(
-      ops, ops_count, table, &in_txn_limit, force_non_bufferable));
-  return PgDocResponse(std::move(result), in_txn_limit);
+      ops, ops_count, table, in_txn_limit_for_reads_already_set, force_non_bufferable));
+  return PgDocResponse(std::move(result));
 }
 
 //-------------------------------------------------------------------------------------------------
diff --git a/src/yb/yql/pggate/pg_doc_op.h b/src/yb/yql/pggate/pg_doc_op.h
index f47dd3e3a307..5faf8c2f2a3c 100644
--- a/src/yb/yql/pggate/pg_doc_op.h
+++ b/src/yb/yql/pggate/pg_doc_op.h
@@ -213,11 +213,8 @@ class PgDocResult {
 class PgDocResponse {
  public:
   struct Data {
-    Data(const rpc::CallResponsePtr& response_, uint64_t in_txn_limit_)
-        : response(response_), in_txn_limit(in_txn_limit_) {
-    }
+    explicit Data(const rpc::CallResponsePtr& response_) : response(response_) {}
     rpc::CallResponsePtr response;
-    uint64_t in_txn_limit;
   };
 
   class Provider {
@@ -229,7 +226,7 @@ class PgDocResponse {
   using ProviderPtr = std::unique_ptr<Provider>;
 
   PgDocResponse() = default;
-  PgDocResponse(PerformFuture future, uint64_t in_txn_limit);
+  explicit PgDocResponse(PerformFuture future);
   explicit PgDocResponse(ProviderPtr provider);
 
   bool Valid() const;
@@ -238,7 +235,6 @@ class PgDocResponse {
  private:
   struct PerformInfo {
     PerformFuture future;
-    uint64_t in_txn_limit;
   };
   std::variant<PerformInfo, ProviderPtr> holder_;
 };
@@ -248,7 +244,7 @@ class PgDocOp : public std::enable_shared_from_this<PgDocOp> {
   using SharedPtr = std::shared_ptr<PgDocOp>;
 
   using Sender = std::function<Result<PgDocResponse>(
-      PgSession*, const PgsqlOpPtr*, size_t, const PgTableDesc&, uint64_t, ForceNonBufferable)>;
+      PgSession*, const PgsqlOpPtr*, size_t, const PgTableDesc&, bool*, ForceNonBufferable)>;
 
   struct OperationRowOrder {
     OperationRowOrder(const PgsqlOpPtr& operation_, int64_t order_)
@@ -331,7 +327,7 @@ class PgDocOp : public std::enable_shared_from_this<PgDocOp> {
     const PgSession::ScopedRefPtr& pg_session, PgTable* table,
     const Sender& = Sender(&PgDocOp::DefaultSender));
 
-  uint64_t& GetInTxnLimit();
+  bool* GetInTxnLimitForReadsAlreadySet();
 
   // Populate Protobuf requests using the collected information for this DocDB operator.
   virtual Result<bool> DoCreateRequests() = 0;
@@ -346,17 +342,23 @@ class PgDocOp : public std::enable_shared_from_this<PgDocOp> {
   // Session control.
   PgSession::ScopedRefPtr pg_session_;
 
-  // This time is set at the start (i.e., before sending the first batch of PgsqlOp ops) and must
-  // stay the same for the lifetime of the PgDocOp.
+  // Helps identify if the in txn limit for read operations is already picked for this PgDocOp.
+  // It is false initially and set to true when the first batch of PgsqlOp read ops are being sent
+  // to the local tserver proxy (since that will set the in_txn_limit for reads).
   //
-  // Each query must only see data written by earlier queries in the same transaction, not data
-  // written by itself. Setting it at the start ensures that future operations of the PgDocOp only
-  // see data written by previous queries.
+  // Thereafter, the in_txn_limit must stay the same for all reads ops in the lifetime of this
+  // PgDocOp.
+  //
+  // It helps ensure that each query sees only data written by earlier queries in the same
+  // transaction, not data written by itself. Setting it at the start ensures that future read
+  // operations of the PgDocOp only see data written by previous queries.
   //
   // NOTE: Each query might result in many PgDocOps. So using 1 in_txn_limit_ per PgDocOp is not
   // enough. The same should be used across all PgDocOps in the query. This is ensured by the use
-  // of statement_in_txn_limit in yb_exec_params of EState.
-  uint64_t in_txn_limit_ = 0;
+  // of stmt_in_txn_limit_for_reads_already_set in yb_exec_params of EState.
+  //
+  // See src/yb/yql/pggate/README.txt for more details.
+  bool in_txn_limit_for_reads_already_set_ = false;
 
   // Target table.
   PgTable& table_;
@@ -457,7 +459,7 @@ class PgDocOp : public std::enable_shared_from_this<PgDocOp> {
 
   static Result<PgDocResponse> DefaultSender(
       PgSession* session, const PgsqlOpPtr* ops, size_t ops_count, const PgTableDesc& table,
-      uint64_t in_txn_limit, ForceNonBufferable force_non_bufferable);
+      bool* in_txn_limit_for_reads_already_set, ForceNonBufferable force_non_bufferable);
 
   // Result set either from selected or returned targets is cached in a list of strings.
   // Querying state variables.
diff --git a/src/yb/yql/pggate/pg_session.cc b/src/yb/yql/pggate/pg_session.cc
index 87d357d55135..8f289307bdcb 100644
--- a/src/yb/yql/pggate/pg_session.cc
+++ b/src/yb/yql/pggate/pg_session.cc
@@ -177,8 +177,28 @@ class PgSession::RunHelper {
 
   Status Apply(const PgTableDesc& table,
                PgsqlOpPtr op,
-               uint64_t* in_txn_limit,
+               bool* in_txn_limit_for_reads_already_set,
                ForceNonBufferable force_non_bufferable) {
+    // Refer src/yb/yql/pggate/README.txt for details about buffering.
+
+    // TODO(buffering): Consider the following scenario:
+    // 1) A read op arrives here and adds itself to operations_.
+    // 2) Two writes ops follow which change the same row and are added to operations_.
+    //    Should they not be flushed separately? (as per requirement 2b in the README)
+    //
+    // Moreover, consider a situation in which they are flushed separetely, but the in_txn_limit
+    // computation might be incorrect:
+    // 1) A non-bufferable write op on key k1 enters Apply() and is flushed.
+    // 2) A read which has a preset in_txn_limit enters and is added to operations_. The
+    //    in_txn_limit happens to be smaller than the write time of the write op in (1).
+    // 3) Another write to key k1 is added to operations_. But it will end up using the preset
+    //    in_txn_limit. Isn't this incorrect?
+    //
+    // Both scenarios might not occur with any sort of SQL statement. But we should still try to
+    // find statements that can lead to this and fix these cases. Even if we don't find anything
+    // that leads to such scnearios, we should fix these anyway (unless we prove these scenarios
+    // can never occur).
+
     auto& buffer = pg_session_.buffer_;
     // Try buffering this operation if it is a write operation, buffering is enabled and no
     // operations have been already applied to current session (yb session does not exist).
@@ -192,17 +212,43 @@ class PgSession::RunHelper {
                           IsTransactional());
     }
     bool read_only = op->is_read();
+    if (IsTransactional() && !pg_session_.pg_txn_manager_->IsDdlMode()) {
+      // TODO: Do DDL transactions not need in_txn_limit?
+      //
+      // For reads, the in_txn_limit should be picked once for a SQL statement and the same
+      // in_txn_limit should be picked for all later reads in that statement. For a new statement,
+      // a new in_txn_limit would be picked for reads (this would happen because
+      // in_txn_limit_for_reads_already_set would be false the first time any new statement reaches
+      // this execution point).
+      //
+      // This logic satisfies requirement 1 mentioned in README.txt.
+      if (in_txn_limit_for_reads_already_set && !*in_txn_limit_for_reads_already_set) {
+        *in_txn_limit_for_reads_already_set = true;
+        pg_session_.ResetInTxnLimitForReadOpsOnce();
+      }
+    }
+
     // Flush all buffered operations (if any) before performing non-bufferable operation
     if (!Empty(buffer)) {
       SCHECK(operations_.empty(),
             IllegalState,
             "Buffered operations must be flushed before applying first non-bufferable operation");
-      // Buffered operations can't be combined within single RPC with non bufferable operation
-      // in case non bufferable operation has preset in_txn_limit.
-      // Buffered operations must be flushed independently in this case.
-      // Also operations for catalog session can be combined with buffered operations
-      // as catalog session is used for read-only operations.
-      if ((IsTransactional() && in_txn_limit && *in_txn_limit) || IsCatalog()) {
+      // Buffered write operations can't be combined within a single RPC with non-bufferable read
+      // operations in case the reads have a preset in_txn_limit. This is because as per requirement
+      // 1 and 2b) in README.txt, the writes and reads will require a different in_txn_limit. In
+      // case the in_txn_limit wasn't yet picked for the reads, they can be flushed together with
+      // the writes since both would use the current hybrid time as the in_txn_limit.
+      //
+      // Note however that the buffer has to be flushed before the non-buffered op if:
+      // 1) it is a non-buffered read is on a table that is touched by the buffered writes
+      // 2) it is a non-buffered write touches the same key as a buffered write
+      //
+      // Also operations for a catalog session are read-only operations. And "buffer" only buffers
+      // write operations. Since the writes and catalog reads belong to different session types (as
+      // per PgClientSession), we can't send them to the local tserver proxy in 1 rpc, so we flush
+      // the buffer before performing catalog reads.
+      if ((IsTransactional() && in_txn_limit_for_reads_already_set &&
+           *in_txn_limit_for_reads_already_set) || IsCatalog()) {
         RETURN_NOT_OK(buffer.Flush());
       } else {
         operations_ = VERIFY_RESULT(buffer.FlushTake(table, *op, IsTransactional()));
@@ -228,8 +274,7 @@ class PgSession::RunHelper {
           (RowMarkNeedsHigherPriority(row_mark_type) ? kHigherPriorityRange : kLowerPriorityRange);
     read_only = read_only && !IsValidRowMarkType(row_mark_type);
 
-    return pg_session_.pg_txn_manager_->CalculateIsolation(
-        read_only, txn_priority_requirement, in_txn_limit);
+    return pg_session_.pg_txn_manager_->CalculateIsolation(read_only, txn_priority_requirement);
   }
 
   Result<PerformFuture> Flush(std::string&& cache_key) {
@@ -545,10 +590,8 @@ Result<PerformFuture> PgSession::FlushOperations(BufferableOperations ops, bool
       txn_priority_requirement = kHighestPriority;
     }
 
-    // Use 0 as the value of in_txn_limit to force setting current time as txn limit
-    uint64_t in_txn_limit = 0;
     RETURN_NOT_OK(pg_txn_manager_->CalculateIsolation(
-        false /* read_only */, txn_priority_requirement, &in_txn_limit));
+        false /* read_only */, txn_priority_requirement));
   }
 
   // In case of flushing of non-transactional operations it is required to set read time with the
@@ -615,6 +658,11 @@ Result<PerformFuture> PgSession::Perform(BufferableOperations&& ops, PerformOpti
     options.mutable_caching_info()->set_key(std::move(ops_options.cache_key));
   }
 
+  if (reset_in_txn_limit_for_read_ops_once_) {
+    options.set_reset_in_txn_limit_for_read_ops(true);
+    reset_in_txn_limit_for_read_ops_once_ = false;
+  }
+
   pg_client_.PerformAsync(&options, &ops.operations, [promise](const PerformResult& result) {
     promise->set_value(result);
   });
@@ -796,7 +844,7 @@ Status PgSession::ValidatePlacement(const std::string& placement_info) {
 
 template<class Generator>
 Result<PerformFuture> PgSession::DoRunAsync(
-    const Generator& generator, uint64_t* in_txn_limit,
+    const Generator& generator, bool* in_txn_limit_for_reads_already_set,
     ForceNonBufferable force_non_bufferable, std::string&& cache_key) {
   auto table_op = generator();
   SCHECK(!table_op.IsEmpty(), IllegalState, "Operation list must not be empty");
@@ -815,32 +863,37 @@ Result<PerformFuture> PgSession::DoRunAsync(
         op_session_type, group_session_type,
         IllegalState, "Operations on different sessions can't be mixed");
     has_write_ops_in_ddl_mode_ = has_write_ops_in_ddl_mode_ || (ddl_mode && !IsReadOnly(**op));
-    RETURN_NOT_OK(runner.Apply(*table, *op, in_txn_limit, force_non_bufferable));
+    RETURN_NOT_OK(runner.Apply(
+        *table, *op, in_txn_limit_for_reads_already_set, force_non_bufferable));
   }
   return runner.Flush(std::move(cache_key));
 }
 
 Result<PerformFuture> PgSession::RunAsync(const OperationGenerator& generator,
-                                          uint64_t* in_txn_limit,
+                                          bool* in_txn_limit_for_reads_already_set,
                                           ForceNonBufferable force_non_bufferable) {
   return DoRunAsync(
-      generator, in_txn_limit, force_non_bufferable, std::string() /* cache_key */);
+      generator, in_txn_limit_for_reads_already_set, force_non_bufferable,
+      std::string() /* cache_key */);
 }
 
 Result<PerformFuture> PgSession::RunAsync(const ReadOperationGenerator& generator,
-                                          uint64_t* in_txn_limit,
+                                          bool* in_txn_limit_for_reads_already_set,
                                           ForceNonBufferable force_non_bufferable) {
   return DoRunAsync(
-      generator, in_txn_limit, force_non_bufferable, std::string() /* cache_key */);
+      generator, in_txn_limit_for_reads_already_set, force_non_bufferable,
+      std::string() /* cache_key */);
 }
 
 Result<PerformFuture> PgSession::RunAsyncCacheable(
-    const ReadOperationGenerator& generator, uint64_t* in_txn_limit, std::string&& cache_key) {
+    const ReadOperationGenerator& generator,
+    bool* in_txn_limit_for_reads_already_set, std::string&& cache_key) {
   SCHECK(!cache_key.empty(), InvalidArgument, "Cache key can't be empty");
   // Ensure no buffered requests will be added to cached request.
   RETURN_NOT_OK(buffer_.Flush());
   return DoRunAsync(
-      generator, in_txn_limit, ForceNonBufferable::kFalse, std::move(cache_key));
+      generator, in_txn_limit_for_reads_already_set, ForceNonBufferable::kFalse,
+      std::move(cache_key));
 }
 
 Result<bool> PgSession::CheckIfPitrActive() {
diff --git a/src/yb/yql/pggate/pg_session.h b/src/yb/yql/pggate/pg_session.h
index 8503e863210f..d6c1869e10bc 100644
--- a/src/yb/yql/pggate/pg_session.h
+++ b/src/yb/yql/pggate/pg_session.h
@@ -248,13 +248,14 @@ class PgSession : public RefCountedThreadSafe<PgSession> {
   }
 
   Result<PerformFuture> RunAsync(
-      const OperationGenerator& generator, uint64_t* in_txn_limit,
+      const OperationGenerator& generator, bool* in_txn_limit_for_reads_already_set,
       ForceNonBufferable force_non_bufferable = ForceNonBufferable::kFalse);
   Result<PerformFuture> RunAsync(
-      const ReadOperationGenerator& generator, uint64_t* in_txn_limit,
+      const ReadOperationGenerator& generator, bool* in_txn_limit_for_reads_already_set,
       ForceNonBufferable force_non_bufferable = ForceNonBufferable::kFalse);
   Result<PerformFuture> RunAsyncCacheable(
-      const ReadOperationGenerator& generator, uint64_t* in_txn_limit, std::string&& cache_key);
+      const ReadOperationGenerator& generator, bool* in_txn_limit_for_reads_already_set,
+      std::string&& cache_key);
 
   // Smart driver functions.
   // -------------
@@ -341,6 +342,12 @@ class PgSession : public RefCountedThreadSafe<PgSession> {
 
   void GetAndResetOperationFlushRpcStats(uint64_t* count, uint64_t* wait_time);
 
+  void ResetInTxnLimitForReadOps();
+
+  void ResetInTxnLimitForReadOpsOnce() {
+    reset_in_txn_limit_for_read_ops_once_ = true;
+  }
+
  private:
   Result<PgTableDescPtr> DoLoadTable(const PgObjectId& table_id, bool fail_on_cache_hit);
   Result<PerformFuture> FlushOperations(BufferableOperations ops, bool transactional);
@@ -362,7 +369,7 @@ class PgSession : public RefCountedThreadSafe<PgSession> {
 
   template<class Generator>
   Result<PerformFuture> DoRunAsync(
-      const Generator& generator, uint64_t* in_txn_limit,
+      const Generator& generator, bool* in_txn_limit_for_reads_already_set,
       ForceNonBufferable force_non_bufferable, std::string&& cache_key);
 
   struct TxnSerialNoPerformInfo {
@@ -407,6 +414,7 @@ class PgSession : public RefCountedThreadSafe<PgSession> {
   const YBCPgCallbacks& pg_callbacks_;
   bool has_write_ops_in_ddl_mode_ = false;
   std::variant<TxnSerialNoPerformInfo> last_perform_on_txn_serial_no_;
+  bool reset_in_txn_limit_for_read_ops_once_ = false;
 };
 
 }  // namespace pggate
diff --git a/src/yb/yql/pggate/pg_txn_manager.cc b/src/yb/yql/pggate/pg_txn_manager.cc
index b00c02473dc9..244b6d28121f 100644
--- a/src/yb/yql/pggate/pg_txn_manager.cc
+++ b/src/yb/yql/pggate/pg_txn_manager.cc
@@ -231,22 +231,12 @@ uint64_t PgTxnManager::NewPriority(TxnPriorityRequirement txn_priority_requireme
 }
 
 Status PgTxnManager::CalculateIsolation(bool read_only_op,
-                                        TxnPriorityRequirement txn_priority_requirement,
-                                        uint64_t* in_txn_limit) {
+                                        TxnPriorityRequirement txn_priority_requirement) {
   if (IsDdlMode()) {
     VLOG_TXN_STATE(2);
     return Status::OK();
   }
 
-  auto se = ScopeExit([this, in_txn_limit] {
-    if (in_txn_limit) {
-      if (!*in_txn_limit) {
-        *in_txn_limit = clock_->Now().ToUint64();
-      }
-      in_txn_limit_ = HybridTime(*in_txn_limit);
-    }
-  });
-
   VLOG_TXN_STATE(2);
   if (!txn_in_progress_) {
     return RecreateTransaction(SavePriority::kFalse);
@@ -368,7 +358,6 @@ void PgTxnManager::ResetTxnAndSession() {
   txn_in_progress_ = false;
   isolation_level_ = IsolationLevel::NON_TRANSACTIONAL;
   priority_ = 0;
-  in_txn_limit_ = HybridTime();
   ++txn_serial_no_;
   active_sub_transaction_id_ = 0;
 
@@ -433,9 +422,6 @@ uint64_t PgTxnManager::SetupPerformOptions(tserver::PgPerformOptionsPB* options)
   options->set_txn_serial_no(txn_serial_no_);
   options->set_active_sub_transaction_id(active_sub_transaction_id_);
 
-  if (txn_in_progress_ && in_txn_limit_) {
-    options->set_in_txn_limit_ht(in_txn_limit_.ToUint64());
-  }
   if (use_saved_priority_) {
     options->set_use_existing_priority(true);
   } else {
diff --git a/src/yb/yql/pggate/pg_txn_manager.h b/src/yb/yql/pggate/pg_txn_manager.h
index 6af5f625ef99..9ae6e9d67d11 100644
--- a/src/yb/yql/pggate/pg_txn_manager.h
+++ b/src/yb/yql/pggate/pg_txn_manager.h
@@ -51,9 +51,7 @@ class PgTxnManager : public RefCountedThreadSafe<PgTxnManager> {
   virtual ~PgTxnManager();
 
   Status BeginTransaction();
-  Status CalculateIsolation(bool read_only_op,
-                            TxnPriorityRequirement txn_priority_requirement,
-                            uint64_t* in_txn_limit = nullptr);
+  Status CalculateIsolation(bool read_only_op, TxnPriorityRequirement txn_priority_requirement);
   Status RecreateTransaction();
   Status RestartTransaction();
   Status ResetTransactionReadPoint();
@@ -122,7 +120,6 @@ class PgTxnManager : public RefCountedThreadSafe<PgTxnManager> {
   // and cancels the other transaction.
   uint64_t priority_ = 0;
   SavePriority use_saved_priority_ = SavePriority::kFalse;
-  HybridTime in_txn_limit_;
 
   PgCallbacks pg_callbacks_;
 
diff --git a/src/yb/yql/pggate/pggate.cc b/src/yb/yql/pggate/pggate.cc
index f9910a49ae55..d93ad1d4ff4a 100644
--- a/src/yb/yql/pggate/pggate.cc
+++ b/src/yb/yql/pggate/pggate.cc
@@ -165,8 +165,7 @@ class PrecastRequestSender {
     using State = PgDocResponse::Data;
     using StatePtr = std::shared_ptr<State>;
 
-    explicit ResponseProvider(const StatePtr& state)
-        : state_(state) {}
+    explicit ResponseProvider(const StatePtr& state) : state_(state) {}
 
     Result<PgDocResponse::Data> Get() override {
       SCHECK(state_->response, IllegalState, "Response is not set");
@@ -180,22 +179,19 @@ class PrecastRequestSender {
  public:
   Result<PgDocResponse> Send(
       PgSession* session, const PgsqlOpPtr* ops, size_t ops_count, const PgTableDesc& table,
-      uint64_t in_txn_limit, ForceNonBufferable force_non_bufferable) {
+      bool* in_txn_limit_for_reads_already_set, ForceNonBufferable force_non_bufferable) {
     if (!collecting_mode_) {
       auto future = VERIFY_RESULT(session->RunAsync(
-          ops, ops_count, table, &in_txn_limit, force_non_bufferable));
-      return PgDocResponse(std::move(future), in_txn_limit);
+          ops, ops_count, table, in_txn_limit_for_reads_already_set, force_non_bufferable));
+      return PgDocResponse(std::move(future));
     }
-    // For now PrecastRequestSender can work with zero in txn limit only.
-    // Zero read time means that current time should be used as in txn limit.
-    RSTATUS_DCHECK(!in_txn_limit, IllegalState, "Only zero read time is expected");
     for (auto end = ops + ops_count; ops != end; ++ops) {
       ops_.emplace_back(*ops, table);
     }
     if (!provider_state_) {
-      provider_state_ = std::make_shared<ResponseProvider::State>(
-          rpc::CallResponsePtr(), 0 /* in_txn_limit */);
+      provider_state_ = std::make_shared<ResponseProvider::State>(rpc::CallResponsePtr());
     }
+    in_txn_limit_for_reads_already_set_ = in_txn_limit_for_reads_already_set;
     return PgDocResponse(std::make_unique<ResponseProvider>(provider_state_));
   }
 
@@ -222,7 +218,7 @@ class PrecastRequestSender {
           }
           auto& info = *i++;
           return TO{.operation = &info.operation, .table = info.table};
-        }), &provider_state_->in_txn_limit));
+        }), in_txn_limit_for_reads_already_set_));
     provider_state_->response = VERIFY_RESULT(perform_future.Get());
     return Status::OK();
   }
@@ -230,6 +226,7 @@ class PrecastRequestSender {
   bool collecting_mode_ = true;
   ResponseProvider::StatePtr provider_state_;
   boost::container::small_vector<OperationInfo, 16> ops_;
+  bool* in_txn_limit_for_reads_already_set_;
 };
 
 Status FetchExistingYbctids(PgSession::ScopedRefPtr session,
@@ -247,8 +244,9 @@ Status FetchExistingYbctids(PgSession::ScopedRefPtr session,
   boost::container::small_vector<std::unique_ptr<PgDocReadOp>, 16> doc_ops;
   auto request_sender = [&precast_sender](
       PgSession* session, const PgsqlOpPtr* ops, size_t ops_count, const PgTableDesc& table,
-      uint64_t in_txn_limit, ForceNonBufferable force_non_bufferable) {
-    return precast_sender.Send(session, ops, ops_count, table, in_txn_limit, force_non_bufferable);
+      bool* in_txn_limit_for_reads_already_set, ForceNonBufferable force_non_bufferable) {
+    return precast_sender.Send(
+        session, ops, ops_count, table, in_txn_limit_for_reads_already_set, force_non_bufferable);
   };
   // Start all the doc_ops to read from docdb in parallel, one doc_op per table ID.
   // Each doc_op will use request_sender to send all the requests with single perform RPC.
diff --git a/src/yb/yql/pggate/ybc_pg_typedefs.h b/src/yb/yql/pggate/ybc_pg_typedefs.h
index 876b04c59cfe..ba7d1ed8e167 100644
--- a/src/yb/yql/pggate/ybc_pg_typedefs.h
+++ b/src/yb/yql/pggate/ybc_pg_typedefs.h
@@ -292,7 +292,7 @@ typedef struct PgExecParameters {
   int wait_policy = 2; // Cast to yb::WaitPolicy for C++ use. (2 is for yb::WAIT_ERROR)
   char *bfinstr = NULL;
   uint64_t backfill_read_time = 0;
-  uint64_t* statement_in_txn_limit = NULL;
+  bool *stmt_in_txn_limit_for_reads_already_set = NULL;
   char *partition_key = NULL;
   PgExecOutParam *out_param = NULL;
   bool is_index_backfill = false;
@@ -305,7 +305,7 @@ typedef struct PgExecParameters {
   int wait_policy; // Cast to LockWaitPolicy for C use
   char *bfinstr;
   uint64_t backfill_read_time;
-  uint64_t* statement_in_txn_limit;
+  bool *stmt_in_txn_limit_for_reads_already_set;
   char *partition_key;
   PgExecOutParam *out_param;
   bool is_index_backfill;
diff --git a/src/yb/yql/pggate/ybc_pggate.cc b/src/yb/yql/pggate/ybc_pggate.cc
index 0d46b754db4e..ed0de540ae43 100644
--- a/src/yb/yql/pggate/ybc_pggate.cc
+++ b/src/yb/yql/pggate/ybc_pggate.cc
@@ -41,6 +41,7 @@
 #include "yb/docdb/primitive_value.h"
 #include "yb/docdb/value_type.h"
 
+#include "yb/server/skewed_clock.h"
 #include "yb/yql/pggate/pg_expr.h"
 #include "yb/yql/pggate/pg_gate_fwd.h"
 #include "yb/yql/pggate/pg_memctx.h"
@@ -88,6 +89,10 @@ DEFINE_NON_RUNTIME_bool(ysql_catalog_preload_additional_tables, false,
             "If true, YB catalog preloads additional tables upon "
             "connection creation and cache refresh.");
 
+DEFINE_test_flag(bool, allow_skewed_clock_in_ysql, false,
+                 "If true, allows use of a skewed clock to simulate fake clock skew "
+                 "in all HybridClock instances used by this process.");
+
 namespace yb {
 namespace pggate {
 
@@ -176,6 +181,12 @@ void YBCInitPgGateEx(const YBCPgTypeEntity *data_type_table, int count, PgCallba
 extern "C" {
 
 void YBCInitPgGate(const YBCPgTypeEntity *data_type_table, int count, PgCallbacks pg_callbacks) {
+  if (FLAGS_TEST_allow_skewed_clock_in_ysql) {
+    // TODO: We should get rid of hybrid clock usage on YSQL (see #16034). However, this is added to
+    // allow simulating and testing of some known bugs until we remove HybridClock usage.
+    server::SkewedClock::Register();
+  }
+
   YBCInitPgGateEx(data_type_table, count, pg_callbacks, nullptr);
 }
 
diff --git a/src/yb/yql/pgwrapper/CMakeLists.txt b/src/yb/yql/pgwrapper/CMakeLists.txt
index 48043f06162f..305b123289c7 100644
--- a/src/yb/yql/pgwrapper/CMakeLists.txt
+++ b/src/yb/yql/pgwrapper/CMakeLists.txt
@@ -91,6 +91,7 @@ ADD_YB_LIBRARY(ysql_upgrade
 set(YB_TEST_LINK_LIBS yb_pgwrapper ql-dml-test-base pg_wrapper_test_base tools_test_utils
     geo_transactions_test_base ${YB_MIN_TEST_LIBS})
 ADD_YB_TEST(pg_catalog_perf-test)
+ADD_YB_TEST(pg_clock_skew-test)
 ADD_YB_TEST(pg_conn-test)
 ADD_YB_TEST(pg_ddl_concurrency-test)
 ADD_YB_TEST(pg_fkey-test)
diff --git a/src/yb/yql/pgwrapper/pg_clock_skew-test.cc b/src/yb/yql/pgwrapper/pg_clock_skew-test.cc
new file mode 100644
index 000000000000..48615578db60
--- /dev/null
+++ b/src/yb/yql/pgwrapper/pg_clock_skew-test.cc
@@ -0,0 +1,81 @@
+// Copyright (c) YugaByte, Inc.
+//
+// Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
+// in compliance with the License.  You may obtain a copy of the License at
+//
+// http://www.apache.org/licenses/LICENSE-2.0
+//
+// Unless required by applicable law or agreed to in writing, software distributed under the License
+// is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
+// or implied.  See the License for the specific language governing permissions and limitations
+// under the License.
+
+#include <memory>
+#include <string>
+
+#include "yb/client/yb_table_name.h"
+#include "yb/common/common.pb.h"
+#include "yb/integration-tests/cql_test_util.h"
+#include "yb/master/master_defaults.h"
+#include "yb/server/skewed_clock.h"
+#include "yb/tserver/mini_tablet_server.h"
+#include "yb/tserver/tablet_server.h"
+#include "yb/util/debug-util.h"
+#include "yb/util/lw_function.h"
+#include "yb/util/metrics.h"
+#include "yb/util/status.h"
+#include "yb/util/test_macros.h"
+
+#include "yb/yql/pgwrapper/libpq_utils.h"
+#include "yb/yql/pgwrapper/pg_mini_test_base.h"
+
+DECLARE_bool(TEST_allow_skewed_clock_in_ysql);
+
+namespace yb {
+namespace pgwrapper {
+namespace {
+
+class PgClockSkewTest : public PgMiniTestBase {
+ protected:
+  void SetUp() override {
+    FLAGS_TEST_allow_skewed_clock_in_ysql = true;
+    server::SkewedClock::Register();
+    PgMiniTestBase::SetUp();
+  }
+
+  size_t NumTabletServers() override {
+    return 3;
+  }
+
+  std::vector<uint16_t> TabletServerClockSkew() override {
+    return std::vector<uint16_t>({100, 200, 300});
+  }
+};
+
+} // namespace
+
+TEST_F(PgClockSkewTest, InTxnLimitBug) {
+  // This test case is inspired from #15933 which is in turn caused due to #16034.
+  // Below is a simpler test case that also fails due to #15933.
+  //
+  // TODO: The bug gets masked due to a fix in commit 03055c43. So, if you want to see the
+  // constraint violation on the index key, that commit needs to be reverted. Does this test
+  // serve any purpose in that case?
+  auto conn = ASSERT_RESULT(Connect());
+
+  ASSERT_OK(conn.Execute(
+      "CREATE TABLE test (id int NOT NULL, value int DEFAULT 0 NOT NULL,"
+      " CONSTRAINT test_pkey PRIMARY KEY((id) HASH));"));
+
+  ASSERT_OK(conn.Execute(
+      "CREATE UNIQUE INDEX test_value_key1 ON test USING lsm (value HASH)"
+      " WHERE (value IS NOT NULL);"));
+
+  ASSERT_OK(conn.Execute("INSERT INTO test SELECT s, s from generate_series(1, 10) as s;"));
+  for (int i=0; i < 10; i++) {
+    ASSERT_OK(conn.ExecuteFormat("UPDATE test SET value=$0 WHERE id = $1", i+10, i));
+  }
+}
+
+} // namespace pgwrapper
+} // namespace yb
diff --git a/src/yb/yql/pgwrapper/pg_mini_test_base.cc b/src/yb/yql/pgwrapper/pg_mini_test_base.cc
index 0a22bee7204a..d002b7f4fc42 100644
--- a/src/yb/yql/pgwrapper/pg_mini_test_base.cc
+++ b/src/yb/yql/pgwrapper/pg_mini_test_base.cc
@@ -26,6 +26,8 @@
 #include "yb/util/metrics.h"
 #include "yb/util/tsan_util.h"
 
+#include "yb/server/skewed_clock.h"
+
 DECLARE_bool(enable_ysql);
 DECLARE_bool(hide_pg_catalog_table_creation_logs);
 DECLARE_bool(master_auto_run_initdb);
@@ -68,7 +70,7 @@ void PgMiniTestBase::SetUp() {
   };
   OverrideMiniClusterOptions(&mini_cluster_opt);
   cluster_ = std::make_unique<MiniCluster>(mini_cluster_opt);
-  ASSERT_OK(cluster_->Start(ExtraTServerOptions()));
+  ASSERT_OK(cluster_->Start(ExtraTServerOptions(), TabletServerClockSkew()));
 
   ASSERT_OK(WaitForInitDb(cluster_.get()));
 
diff --git a/src/yb/yql/pgwrapper/pg_mini_test_base.h b/src/yb/yql/pgwrapper/pg_mini_test_base.h
index 824e0bed815f..2e2ad8e7d209 100644
--- a/src/yb/yql/pgwrapper/pg_mini_test_base.h
+++ b/src/yb/yql/pgwrapper/pg_mini_test_base.h
@@ -48,6 +48,10 @@ class PgMiniTestBase : public MiniClusterTestWithClient<MiniCluster> {
     return 3;
   }
 
+  virtual std::vector<uint16_t> TabletServerClockSkew() {
+    return std::vector<uint16_t>();
+  }
+
   // This allows changing mini cluster options before the mini cluster is started.
   virtual void OverrideMiniClusterOptions(MiniClusterOptions* options);
 
